#include<iostream>
#include<algorithm>
#include<vector>
#include<list>

template<typename T>
struct print : public std::unary_function<T, void>
{
  std::ostream& os;
  int count;

  print(std::ostream& out) : os(out), count(0) {}
  void operator() (T x) { os << x << ' '; ++count; }
};

int main()
{
  typedef std::list<int> coll_t;
  //typedef std::vector<int> coll_t;
  coll_t coll;
  coll.push_back(1);
  coll.push_back(4);
  coll.push_back(2);
  coll.push_back(8);
  coll.push_back(5);
  coll.push_back(7);

  print<int> P = std::for_each(coll.begin(), coll.end(), print<int>(std::cout));
  std::cout << std::endl << P.count << " objects printed." << std::endl;
}
